// ====================================================================
// This file is part of FlexibleSUSY.
//
// FlexibleSUSY is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published
// by the Free Software Foundation, either version 3 of the License,
// or (at your option) any later version.
//
// FlexibleSUSY is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with FlexibleSUSY.  If not, see
// <http://www.gnu.org/licenses/>.
// ====================================================================

// File generated at Thu 17 Aug 2017 11:21:15

#ifndef MSSMNoFVatMGUTHimalaya_TWO_SCALE_SPECTRUM_GENERATOR_H
#define MSSMNoFVatMGUTHimalaya_TWO_SCALE_SPECTRUM_GENERATOR_H

#include "MSSMNoFVatMGUTHimalaya_input_parameters.hpp"
#include "MSSMNoFVatMGUTHimalaya_spectrum_generator_interface.hpp"
#include "MSSMNoFVatMGUTHimalaya_spectrum_generator.hpp"
#include "MSSMNoFVatMGUTHimalaya_two_scale_high_scale_constraint.hpp"
#include "MSSMNoFVatMGUTHimalaya_two_scale_susy_scale_constraint.hpp"
#include "MSSMNoFVatMGUTHimalaya_two_scale_low_scale_constraint.hpp"
#include "MSSMNoFVatMGUTHimalaya_two_scale_model.hpp"
#include "MSSMNoFVatMGUTHimalaya_model_slha.hpp"

#include <tuple>

namespace softsusy { class QedQcd; }

namespace flexiblesusy {

class Two_scale;

template <>
class MSSMNoFVatMGUTHimalaya_spectrum_generator<Two_scale>
   : public MSSMNoFVatMGUTHimalaya_spectrum_generator_interface<Two_scale> {
public:
   MSSMNoFVatMGUTHimalaya_spectrum_generator() = default;
   virtual ~MSSMNoFVatMGUTHimalaya_spectrum_generator() = default;

   std::tuple<MSSMNoFVatMGUTHimalaya<Two_scale> > get_models() const { return std::make_tuple(this->get_model()); }
   std::tuple<MSSMNoFVatMGUTHimalaya_slha<MSSMNoFVatMGUTHimalaya<Two_scale> > > get_models_slha() const { return std::make_tuple(this->get_model_slha()); }

   double get_high_scale() const { return high_scale; }
   double get_susy_scale() const { return susy_scale; }
   double get_low_scale()  const { return low_scale;  }
   double get_pole_mass_scale() const;

   void write_running_couplings(const std::string& filename = "MSSMNoFVatMGUTHimalaya_rgflow.dat") const;

protected:
   virtual void run_except(const softsusy::QedQcd&, const MSSMNoFVatMGUTHimalaya_input_parameters&) override;

private:
   double high_scale{0.}, susy_scale{0.}, low_scale{0.};

   void calculate_spectrum();
};

} // namespace flexiblesusy

#endif
