DIR          := models/NUHMSSMNoFVHimalaya
MODNAME      := NUHMSSMNoFVHimalaya
SARAH_MODEL  := MSSMNoFV
WITH_$(MODNAME) := yes

NUHMSSMNoFVHimalaya_INSTALL_DIR := $(INSTALL_DIR)/$(DIR)

NUHMSSMNoFVHimalaya_MK     := \
		$(DIR)/module.mk

NUHMSSMNoFVHimalaya_SUSY_BETAS_MK := \
		$(DIR)/susy_betas.mk

NUHMSSMNoFVHimalaya_SOFT_BETAS_MK := \
		$(DIR)/soft_betas.mk

NUHMSSMNoFVHimalaya_FlexibleEFTHiggs_MK := \
		$(DIR)/FlexibleEFTHiggs.mk

NUHMSSMNoFVHimalaya_INCLUDE_MK := \
		$(NUHMSSMNoFVHimalaya_SUSY_BETAS_MK) \
		$(NUHMSSMNoFVHimalaya_SOFT_BETAS_MK)

NUHMSSMNoFVHimalaya_SLHA_INPUT := \
		$(DIR)/LesHouches.in.NUHMSSMNoFVHimalaya_generated \
		$(DIR)/LesHouches.in.NUHMSSMNoFVHimalaya

NUHMSSMNoFVHimalaya_GNUPLOT := \
		$(DIR)/NUHMSSMNoFVHimalaya_plot_rgflow.gnuplot \
		$(DIR)/NUHMSSMNoFVHimalaya_plot_spectrum.gnuplot

NUHMSSMNoFVHimalaya_TARBALL := \
		$(MODNAME).tar.gz

LIBNUHMSSMNoFVHimalaya_SRC := \
		$(DIR)/NUHMSSMNoFVHimalaya_a_muon.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_effective_couplings.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_info.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_input_parameters.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_mass_eigenstates.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_observables.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_physical.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_slha_io.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_soft_parameters.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_susy_parameters.cpp \
		$(DIR)/NUHMSSMNoFVHimalaya_utilities.cpp

EXENUHMSSMNoFVHimalaya_SRC := \
		$(DIR)/run_NUHMSSMNoFVHimalaya.cpp \
		$(DIR)/run_cmd_line_NUHMSSMNoFVHimalaya.cpp \
		$(DIR)/scan_NUHMSSMNoFVHimalaya.cpp
LLNUHMSSMNoFVHimalaya_LIB  :=
LLNUHMSSMNoFVHimalaya_OBJ  :=
LLNUHMSSMNoFVHimalaya_SRC  := \
		$(DIR)/NUHMSSMNoFVHimalaya_librarylink.cpp

LLNUHMSSMNoFVHimalaya_MMA  := \
		$(DIR)/NUHMSSMNoFVHimalaya_librarylink.m \
		$(DIR)/run_NUHMSSMNoFVHimalaya.m

LIBNUHMSSMNoFVHimalaya_HDR := \
		$(DIR)/NUHMSSMNoFVHimalaya_a_muon.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_effective_couplings.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_info.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_input_parameters.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_mass_eigenstates.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_model.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_model_slha.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_observables.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_physical.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_slha_io.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_spectrum_generator.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_spectrum_generator_interface.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_soft_parameters.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_susy_parameters.hpp \
		$(DIR)/NUHMSSMNoFVHimalaya_utilities.hpp

ifneq ($(findstring two_scale,$(ALGORITHMS)),)
-include $(DIR)/two_scale.mk
endif
ifneq ($(findstring lattice,$(ALGORITHMS)),)
-include $(DIR)/lattice.mk
endif

ifneq ($(MAKECMDGOALS),showbuild)
ifneq ($(MAKECMDGOALS),tag)
ifneq ($(MAKECMDGOALS),release)
ifneq ($(MAKECMDGOALS),doc)
-include $(NUHMSSMNoFVHimalaya_SUSY_BETAS_MK)
-include $(NUHMSSMNoFVHimalaya_SOFT_BETAS_MK)
-include $(NUHMSSMNoFVHimalaya_FlexibleEFTHiggs_MK)
ifneq ($(MAKECMDGOALS),clean)
ifneq ($(MAKECMDGOALS),distclean)
ifneq ($(MAKECMDGOALS),pack-$(MODNAME)-src)
ifeq ($(findstring clean-,$(MAKECMDGOALS)),)
ifeq ($(findstring distclean-,$(MAKECMDGOALS)),)
ifeq ($(findstring doc-,$(MAKECMDGOALS)),)
$(NUHMSSMNoFVHimalaya_SUSY_BETAS_MK): run-metacode-$(MODNAME)
		@$(CONVERT_DOS_PATHS) $@
$(NUHMSSMNoFVHimalaya_SOFT_BETAS_MK): run-metacode-$(MODNAME)
		@$(CONVERT_DOS_PATHS) $@
$(NUHMSSMNoFVHimalaya_FlexibleEFTHiggs_MK): run-metacode-$(MODNAME)
		@$(CONVERT_DOS_PATHS) $@
endif
endif
endif
endif
endif
endif
endif
endif
endif
endif

# remove duplicates in case all algorithms are used
LIBNUHMSSMNoFVHimalaya_SRC := $(sort $(LIBNUHMSSMNoFVHimalaya_SRC))
EXENUHMSSMNoFVHimalaya_SRC := $(sort $(EXENUHMSSMNoFVHimalaya_SRC))

LIBNUHMSSMNoFVHimalaya_OBJ := \
		$(patsubst %.cpp, %.o, $(filter %.cpp, $(LIBNUHMSSMNoFVHimalaya_SRC))) \
		$(patsubst %.f, %.o, $(filter %.f, $(LIBNUHMSSMNoFVHimalaya_SRC)))

EXENUHMSSMNoFVHimalaya_OBJ := \
		$(patsubst %.cpp, %.o, $(filter %.cpp, $(EXENUHMSSMNoFVHimalaya_SRC))) \
		$(patsubst %.f, %.o, $(filter %.f, $(EXENUHMSSMNoFVHimalaya_SRC)))

EXENUHMSSMNoFVHimalaya_EXE := \
		$(patsubst %.cpp, %.x, $(filter %.cpp, $(EXENUHMSSMNoFVHimalaya_SRC))) \
		$(patsubst %.f, %.x, $(filter %.f, $(EXENUHMSSMNoFVHimalaya_SRC)))

LIBNUHMSSMNoFVHimalaya_DEP := \
		$(LIBNUHMSSMNoFVHimalaya_OBJ:.o=.d)

EXENUHMSSMNoFVHimalaya_DEP := \
		$(EXENUHMSSMNoFVHimalaya_OBJ:.o=.d)

LLNUHMSSMNoFVHimalaya_DEP  := \
		$(patsubst %.cpp, %.d, $(filter %.cpp, $(LLNUHMSSMNoFVHimalaya_SRC)))

LLNUHMSSMNoFVHimalaya_OBJ  := $(LLNUHMSSMNoFVHimalaya_SRC:.cpp=.o)
LLNUHMSSMNoFVHimalaya_LIB  := $(LLNUHMSSMNoFVHimalaya_SRC:.cpp=$(LIBLNK_LIBEXT))

LIBNUHMSSMNoFVHimalaya     := $(DIR)/lib$(MODNAME)$(MODULE_LIBEXT)

METACODE_STAMP_NUHMSSMNoFVHimalaya := $(DIR)/00_DELETE_ME_TO_RERUN_METACODE

ifeq ($(ENABLE_META),yes)
SARAH_MODEL_FILES_NUHMSSMNoFVHimalaya := \
		$(shell $(SARAH_DEP_GEN) $(SARAH_MODEL))
endif

.PHONY:         all-$(MODNAME) clean-$(MODNAME) clean-$(MODNAME)-src \
		clean-$(MODNAME)-dep clean-$(MODNAME)-lib \
		clean-$(MODNAME)-obj distclean-$(MODNAME) \
		run-metacode-$(MODNAME) pack-$(MODNAME)-src

all-$(MODNAME): $(LIBNUHMSSMNoFVHimalaya) $(EXENUHMSSMNoFVHimalaya_EXE)
		@true

ifneq ($(INSTALL_DIR),)
install-src::
		install -d $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		install -m u=rw,g=r,o=r $(LIBNUHMSSMNoFVHimalaya_SRC) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		install -m u=rw,g=r,o=r $(LIBNUHMSSMNoFVHimalaya_HDR) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		install -m u=rw,g=r,o=r $(EXENUHMSSMNoFVHimalaya_SRC) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		install -m u=rw,g=r,o=r $(LLNUHMSSMNoFVHimalaya_SRC) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		install -m u=rw,g=r,o=r $(LLNUHMSSMNoFVHimalaya_MMA) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
		$(INSTALL_STRIPPED) $(NUHMSSMNoFVHimalaya_MK) $(NUHMSSMNoFVHimalaya_INSTALL_DIR) -m u=rw,g=r,o=r
		install -m u=rw,g=r,o=r $(NUHMSSMNoFVHimalaya_INCLUDE_MK) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
ifneq ($(NUHMSSMNoFVHimalaya_SLHA_INPUT),)
		install -m u=rw,g=r,o=r $(NUHMSSMNoFVHimalaya_SLHA_INPUT) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
endif
		install -m u=rw,g=r,o=r $(NUHMSSMNoFVHimalaya_GNUPLOT) $(NUHMSSMNoFVHimalaya_INSTALL_DIR)
endif

clean-$(MODNAME)-dep:
		-rm -f $(LIBNUHMSSMNoFVHimalaya_DEP)
		-rm -f $(EXENUHMSSMNoFVHimalaya_DEP)
		-rm -f $(LLNUHMSSMNoFVHimalaya_DEP)

clean-$(MODNAME)-lib:
		-rm -f $(LIBNUHMSSMNoFVHimalaya)
		-rm -f $(LLNUHMSSMNoFVHimalaya_LIB)

clean-$(MODNAME)-obj:
		-rm -f $(LIBNUHMSSMNoFVHimalaya_OBJ)
		-rm -f $(EXENUHMSSMNoFVHimalaya_OBJ)
		-rm -f $(LLNUHMSSMNoFVHimalaya_OBJ)


clean-$(MODNAME): clean-$(MODNAME)-dep clean-$(MODNAME)-lib clean-$(MODNAME)-obj
		-rm -f $(EXENUHMSSMNoFVHimalaya_EXE)

distclean-$(MODNAME): clean-$(MODNAME)
		@true

clean-generated:: clean-$(MODNAME)-src

clean-obj::     clean-$(MODNAME)-obj

clean::         clean-$(MODNAME)

distclean::     distclean-$(MODNAME)

pack-$(MODNAME)-src:
		tar -czf $(NUHMSSMNoFVHimalaya_TARBALL) \
		$(LIBNUHMSSMNoFVHimalaya_SRC) $(LIBNUHMSSMNoFVHimalaya_HDR) \
		$(EXENUHMSSMNoFVHimalaya_SRC) \
		$(LLNUHMSSMNoFVHimalaya_SRC) $(LLNUHMSSMNoFVHimalaya_MMA) \
		$(NUHMSSMNoFVHimalaya_MK) $(NUHMSSMNoFVHimalaya_INCLUDE_MK) \
		$(NUHMSSMNoFVHimalaya_SLHA_INPUT) $(NUHMSSMNoFVHimalaya_GNUPLOT)

$(LIBNUHMSSMNoFVHimalaya_SRC) $(LIBNUHMSSMNoFVHimalaya_HDR) $(EXENUHMSSMNoFVHimalaya_SRC) $(LLNUHMSSMNoFVHimalaya_SRC) $(LLNUHMSSMNoFVHimalaya_MMA) \
: run-metacode-$(MODNAME)
		@true

run-metacode-$(MODNAME): $(METACODE_STAMP_NUHMSSMNoFVHimalaya)
		@true

ifeq ($(ENABLE_META),yes)
$(METACODE_STAMP_NUHMSSMNoFVHimalaya): $(DIR)/start.m $(DIR)/FlexibleSUSY.m $(META_SRC) $(TEMPLATES) $(SARAH_MODEL_FILES_NUHMSSMNoFVHimalaya)
		"$(MATH)" -run "Get[\"$<\"]; Quit[]"
		@touch "$(METACODE_STAMP_NUHMSSMNoFVHimalaya)"
		@echo "Note: to regenerate NUHMSSMNoFVHimalaya source files," \
		      "please remove the file "
		@echo "\"$(METACODE_STAMP_NUHMSSMNoFVHimalaya)\" and run make"
		@echo "---------------------------------"
else
$(METACODE_STAMP_NUHMSSMNoFVHimalaya):
		@true
endif

$(LIBNUHMSSMNoFVHimalaya_DEP) $(EXENUHMSSMNoFVHimalaya_DEP) $(LLNUHMSSMNoFVHimalaya_DEP) $(LIBNUHMSSMNoFVHimalaya_OBJ) $(EXENUHMSSMNoFVHimalaya_OBJ) $(LLNUHMSSMNoFVHimalaya_OBJ) $(LLNUHMSSMNoFVHimalaya_LIB): \
	CPPFLAGS += $(GSLFLAGS) $(EIGENFLAGS) $(BOOSTFLAGS) $(TSILFLAGS) $(HIMALAYAFLAGS)

ifneq (,$(findstring yes,$(ENABLE_LOOPTOOLS)$(ENABLE_FFLITE)))
$(LIBNUHMSSMNoFVHimalaya_DEP) $(EXENUHMSSMNoFVHimalaya_DEP) $(LLNUHMSSMNoFVHimalaya_DEP) $(LIBNUHMSSMNoFVHimalaya_OBJ) $(EXENUHMSSMNoFVHimalaya_OBJ) $(LLNUHMSSMNoFVHimalaya_OBJ) $(LLNUHMSSMNoFVHimalaya_LIB): \
	CPPFLAGS += $(LOOPFUNCFLAGS)
endif

$(LLNUHMSSMNoFVHimalaya_OBJ) $(LLNUHMSSMNoFVHimalaya_LIB): \
	CPPFLAGS += $(shell $(MATH_INC_PATHS) --math-cmd="$(MATH)" -I --librarylink --mathlink)

$(LIBNUHMSSMNoFVHimalaya): $(LIBNUHMSSMNoFVHimalaya_OBJ)
		$(MODULE_MAKE_LIB_CMD) $@ $^

$(DIR)/%.x: $(DIR)/%.o $(LIBNUHMSSMNoFVHimalaya) $(LIBFLEXI) $(filter-out -%,$(LOOPFUNCLIBS))
		$(CXX) $(LDFLAGS) -o $@ $(call abspathx,$^ $(ADDONLIBS)) $(filter -%,$(LOOPFUNCLIBS)) $(HIMALAYALIBS) $(GSLLIBS) $(BOOSTTHREADLIBS) $(LAPACKLIBS) $(BLASLIBS) $(FLIBS) $(SQLITELIBS) $(TSILLIBS) $(THREADLIBS) $(LDLIBS)

$(LLNUHMSSMNoFVHimalaya_LIB): $(LLNUHMSSMNoFVHimalaya_OBJ) $(LIBNUHMSSMNoFVHimalaya) $(LIBFLEXI) $(filter-out -%,$(LOOPFUNCLIBS))
		$(LIBLNK_MAKE_LIB_CMD) $@ $(CPPFLAGS) $(CFLAGS) $(call abspathx,$^) $(ADDONLIBS) $(filter -%,$(LOOPFUNCLIBS)) $(HIMALAYALIBS) $(GSLLIBS) $(BOOSTTHREADLIBS) $(LAPACKLIBS) $(BLASLIBS) $(FLIBS) $(SQLITELIBS) $(TSILLIBS) $(THREADLIBS) $(LDLIBS)

ALLDEP += $(LIBNUHMSSMNoFVHimalaya_DEP) $(EXENUHMSSMNoFVHimalaya_DEP)
ALLSRC += $(LIBNUHMSSMNoFVHimalaya_SRC) $(EXENUHMSSMNoFVHimalaya_SRC)
ALLLIB += $(LIBNUHMSSMNoFVHimalaya)
ALLEXE += $(EXENUHMSSMNoFVHimalaya_EXE)

ifeq ($(ENABLE_LIBRARYLINK),yes)
ALLDEP += $(LLNUHMSSMNoFVHimalaya_DEP)
ALLSRC += $(LLNUHMSSMNoFVHimalaya_SRC)
ALLLL  += $(LLNUHMSSMNoFVHimalaya_LIB)
endif
